import { prisma } from "@/module/_global";
import { funGetUserById } from "@/module/auth";
import { createLogUserMobile } from "@/module/user";
import { NextResponse } from "next/server";

// PENGHAPUSAN TUGAS DIVISI
export async function DELETE(request: Request, context: { params: { id: string } }) {
   try {
      const { id } = context.params;
      const { user } = (await request.json());

      const userMobile = await funGetUserById({ id: String(user) })
      if (userMobile.id == "null" || userMobile.id == undefined || userMobile.id == "") {
         return NextResponse.json({ success: false, message: "Anda harus login untuk mengakses ini" }, { status: 200 });
      }
      const data = await prisma.divisionProject.count({
         where: {
            id: id,
         },
      });

      if (data == 0) {
         return NextResponse.json(
            {
               success: false,
               message: "Penghapusan tugas gagal, data tugas tidak ditemukan",
            },
            { status: 200 }
         );
      }

      const update = await prisma.divisionProject.update({
         where: {
            id
         },
         data: {
            isActive: false,
         }
      });

      // create log user
      const log = await createLogUserMobile({ act: 'DELETE', desc: 'User menghapus tugas divisi', table: 'divisionProject', data: id, user: userMobile.id })

      return NextResponse.json({ success: true, message: "Tugas berhasil dihapuskan", user: userMobile.id }, { status: 200 });
   } catch (error) {
      console.error(error);
      return NextResponse.json({ success: false, message: "Gagal menghapus tugas, coba lagi nanti (error: 500)", reason: (error as Error).message, }, { status: 500 });
   }
}

// EDIT TASK REPORT
export async function PUT(request: Request, context: { params: { id: string } }) {
   try {
      const { id } = context.params
      const { report, user } = await request.json()

      const userMobile = await funGetUserById({ id: String(user) })
      if (userMobile.id == "null" || userMobile.id == undefined || userMobile.id == "") {
         return NextResponse.json({ success: false, message: "Anda harus login untuk mengakses ini" }, { status: 200 });
      }


      const data = await prisma.divisionProject.count({
         where: {
            id: id
         }
      })

      if (data == 0) {
         return NextResponse.json(
            {
               success: false, message: "Gagal mendapatkan kegiatan, data tidak ditemukan",
            },
            { status: 200 }
         );
      }

      const dataCreate = await prisma.divisionProject.update({
         where: {
            id
         },
         data: {
            report: report
         }
      })

      // create log user
      const log = await createLogUserMobile({ act: 'UPDATE', desc: 'User mengupdate laporan tugas divisi', table: 'divisionProject', data: String(id), user: userMobile.id })

      return NextResponse.json({ success: true, message: "Laporan tugas divisi berhasil diupdate" }, { status: 200 });

   } catch (error) {
      console.error(error);
      return NextResponse.json({ success: false, message: "Gagal mengupdate laporan tugas divisi, coba lagi nanti (error: 500)", reason: (error as Error).message, }, { status: 500 });
   }
}